#ifndef EFL_GENERATED_EVAS_LINE_HH
#define EFL_GENERATED_EVAS_LINE_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "canvas/evas_line.eo.h"
}

#include "canvas/evas_object.eo.hh"

struct evas_line
      : evas_object
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_line(Eo* eo)
      : evas_object(eo)
   {}

   evas_line(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : evas_line(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   evas_line(evas_line const& other)
      : evas_object(eo_ref(other._eo_ptr()))
   {}

   ~evas_line() {}

   /// @brief Retrieves the coordinates of the end points of the given evas line object.
   /// second end point.
   ///
   /// @param x1 The X coordinate of the first point.
   /// @param y1 The Y coordinate of the first point.
   /// @param x2 The X coordinate of the second point.
   /// @param y2 The Y coordinate of the second point.
   ///
   void xy_get(Evas_Coord* x1, Evas_Coord* y1, Evas_Coord* x2, Evas_Coord* y2) const
   {
      eo_do(_eo_ptr(), ::evas_obj_line_xy_get(x1, y1, x2, y2));
   }

   /// @brief @since 1.8
   ///
   /// Sets the coordinates of the end points of the given evas line object.
   ///
   /// @param x1 The X coordinate of the first point.
   /// @param y1 The Y coordinate of the first point.
   /// @param x2 The X coordinate of the second point.
   /// @param y2 The Y coordinate of the second point.
   ///
   void xy_set(Evas_Coord x1, Evas_Coord y1, Evas_Coord x2, Evas_Coord y2) const
   {
      eo_do(_eo_ptr(), ::evas_obj_line_xy_set(x1, y1, x2, y2));
   }

   static Eo_Class const* _eo_class()
   {
      return(EVAS_OBJ_LINE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(EVAS_OBJ_LINE_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void evas_line_xy_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x1, Evas_Coord* y1, Evas_Coord* x2, Evas_Coord* y2)
{
   static_cast<T*>(self->this_)->xy_get(x1, y1, x2, y2);
}

template <typename T>
void evas_line_xy_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x1, Evas_Coord y1, Evas_Coord x2, Evas_Coord y2)
{
   static_cast<T*>(self->this_)->xy_set(x1, y1, x2, y2);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_line >
{
   template <typename T>
   struct type
   {
      virtual void xy_get(Evas_Coord* x1, Evas_Coord* y1, Evas_Coord* x2, Evas_Coord* y2)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , ::evas_obj_line_xy_get(x1, y1, x2, y2));
      }

      virtual void xy_set(Evas_Coord x1, Evas_Coord y1, Evas_Coord x2, Evas_Coord y2)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , ::evas_obj_line_xy_set(x1, y1, x2, y2));
      }

   };
};


template<>
struct operation_description_class_size< ::evas_line >
{
   static const int value = 2;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::evas_line>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::evas_line_xy_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_obj_line_xy_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::evas_line_xy_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_obj_line_xy_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::evas_line >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_line, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

template<>
struct extension_inheritance< ::evas_line>
{
   template <typename T>
   struct type
   {
      operator ::evas_line() const
      {
         return ::evas_line(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

      void xy_get(Evas_Coord* x1, Evas_Coord* y1, Evas_Coord* x2, Evas_Coord* y2)
      {
         eo_do(static_cast<T*>(this)->_eo_ptr(), ::evas_obj_line_xy_get(x1, y1, x2, y2));
      }

      void xy_set(Evas_Coord x1, Evas_Coord y1, Evas_Coord x2, Evas_Coord y2)
      {
         eo_do(static_cast<T*>(this)->_eo_ptr(), ::evas_obj_line_xy_set(x1, y1, x2, y2));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::evas_line>)
{
   return (EVAS_OBJ_LINE_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_LINE_HH

